/* c't Mikrocontroller-im-LAN Demo Source
 * Datei: timer.h
 * Info: Timer und counter
 * Autor: Benjamin Benz (bbe@heise.de)
 * Datum: 16.08.04
*/

#include <avr/io.h>

// Bei einem Prescaler von 1024 zhlt die CPU 14400 Schritte pro Sekunde!!
// Die Werte fr TIMER_X_CLOCK sind Angaben in Hz


//Timer 0 interrupt freq in Hz
#define TIMER_0_CLOCK	200	// Achtung hieran hngt die RTC, 
				// 1000/TIMER_0_CLOCK muss eine ganze Zahl
				// ergeben!!!

//Timer 1 frequency in Hz 
#define TIMER_1_CLOCK	1024	// ADC-Takt (ADC triggert auf TCNT1==OCR1B)

//Timer 2 frequency in Hz 
#define TIMER_2_CLOCK	5619	// Derzeit genutzt fr RC5-Dekodierung

/* initilaisiert Timer 0 und startet ihn */
void timer_0_init(void);
/* initilaisiert Timer 1 und startet ihn */
void timer_1_init(void);
/* initilaisiert Timer 2 und startet ihn */
void timer_2_init(void);

//#define timer_0_reset() TCNT0  = 0x00
